diff --git a/src/fileops.c b/src/fileops.c
index 13b8f6a39fe..542504b2dea 100644
--- a/src/fileops.c
+++ b/src/fileops.c
@@ -19,6 +19,65 @@ int git_futils_mkpath2file(const char *file_path, const mode_t mode)
 		GIT_MKDIR_PATH | GIT_MKDIR_SKIP_LAST | GIT_MKDIR_VERIFY_DIR);
 }
 
+static int is_valid_tmp_path(const char *path)
+{
+	struct stat st;
+
+	if (p_stat(path, &st) != 0)
+		return 0;
+
+	if (!S_ISDIR(st.st_mode))
+		return 0;
+
+	return (p_access(path, W_OK) == 0);
+}
+
+char *git_futils_tmpdir()
+{
+	static char *tmpdir = NULL;
+
+	// use empty as initialized but unknown
+	if (NULL != tmpdir)
+		return tmpdir[0] ? tmpdir : NULL;
+
+	tmpdir = "";
+
+#ifdef GIT_WIN32
+
+	static char tmpbuffer[GIT_PATH_MAX];
+	if (GetTempPathA(GIT_PATH_MAX, tmpbuffer)) {
+		for (char *ptr = tmpbuffer; *ptr; ++ptr)
+			if ('\\' == *ptr)
+				*ptr = '/';
+		return tmpdir = tmpbuffer;
+	}
+
+#else
+
+	static const char *env_tmp_vars[] = {
+		"TMPDIR", "TMP", "TEMP", "USERPROFILE"
+	};
+
+	size_t i;
+
+	for (size_t i = 0; i < sizeof(env_tmp_vars) / sizeof(char *); ++i) {
+		const char *env = getenv(env_tmp_vars[i]);
+		if (!env)
+			continue;
+
+		if (is_valid_tmp_path(env))
+			return tmpdir = env;
+	}
+
+	/* If the environment doesn't say anything, try to use /tmp */
+	if (NULL == tmpdir && is_valid_tmp_path("/tmp"))
+		return tmpdir = "/tmp";
+
+#endif
+
+	return NULL;
+}
+
 int git_futils_mktmp(git_buf *path_out, const char *filename, mode_t mode)
 {
 	int fd;
diff --git a/src/fileops.h b/src/fileops.h
index 62227abaee6..1b458502623 100644
--- a/src/fileops.h
+++ b/src/fileops.h
@@ -136,6 +136,12 @@ typedef enum {
  */
 extern int git_futils_rmdir_r(const char *path, const char *base, uint32_t flags);
 
+/**
+* Return a temporary directory name.
+* @return On success, a directory name, else NULL.
+*/
+extern char *git_futils_tmpdir();
+
 /**
  * Create and open a temporary file with a `_git2_` suffix.
  * Writes the filename into path_out.
